> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rootly.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List shifts

> List shifts



## OpenAPI

````yaml https://rootly-heroku.s3.amazonaws.com/swagger/v1/swagger.json get /v1/shifts
openapi: 3.0.1
info:
  title: Rootly API v1
  version: v1
  description: >+
    # How to generate an API Key?

    - **Organization dropdown** > **Organization Settings** > **API Keys**


    # JSON:API Specification

    Rootly is using **JSON:API** (https://jsonapi.org) specification:

    - JSON:API is a specification for how a client should request that resources
    be fetched or modified, and how a server should respond to those requests.

    - JSON:API is designed to minimize both the number of requests and the
    amount of data transmitted between clients and servers. This efficiency is
    achieved without compromising readability, flexibility, or discoverability.

    - JSON:API requires use of the JSON:API media type
    (**application/vnd.api+json**) for exchanging data.


    # Authentication and Requests

    We use standard HTTP Authentication over HTTPS to authorize your requests.

    ```
      curl --request GET \
    --header 'Content-Type: application/vnd.api+json' \

    --header 'Authorization: Bearer YOUR-TOKEN' \

    --url https://api.rootly.com/v1/incidents

    ```


    <br/>


    # Rate limiting

    - There is a default limit of **5** **GET**, **HEAD**, and **OPTIONS** calls
    **per API key** every **60 seconds** (0 hours). The limit is calculated over
    a **0-hour sliding window** looking back from the current time. While the
    limit can be configured to support higher thresholds, you must first contact
    your **Rootly Customer Success Manager** to make any adjustments.

    - There is a default limit of **3** **POST**, **PUT**, **PATCH** or
    **DELETE** calls **per API key** every **60 seconds** (0 hours). The limit
    is calculated over a **0-hour sliding window** looking back from the current
    time. While the limit can be configured to support higher thresholds, you
    must first contact your **Rootly Customer Success Manager** to make any
    adjustments.

    - When rate limits are exceeded, the API will return a **429 Too Many
    Requests** HTTP status code with the response: `{"error": "Rate limit
    exceeded. Try again later."}`

    - **X-RateLimit headers** are included in every API response, providing
    real-time rate limit information:
      - **X-RateLimit-Limit** - The maximum number of requests permitted and the time window (e.g., "1000, 1000;window=3600" for 1000 requests per hour)
      - **X-RateLimit-Remaining** - The number of requests remaining in the current rate limit window
      - **X-RateLimit-Used** - The number of requests already made in the current window
      - **X-RateLimit-Reset** - The time at which the current rate limit window resets, in UTC epoch seconds

    # Pagination

    - Pagination is supported for all endpoints that return a collection of
    items.

    - Pagination is controlled by the **page** query parameter


    ## Example

    ```
      curl --request GET \
    --header 'Content-Type: application/vnd.api+json' \

    --header 'Authorization: Bearer YOUR-TOKEN' \

    --url https://api.rootly.com/v1/incidents?page[number]=1&page[size]=10

    ```

  x-logo:
    url: https://rootly-heroku.s3.us-east-1.amazonaws.com/swagger/v1/logo.png
servers:
  - url: https://api.rootly.com
security: []
paths:
  /v1/shifts:
    get:
      tags:
        - Shifts
      summary: List shifts
      description: List shifts
      operationId: listShifts
      parameters:
        - name: include
          in: query
          description: >-
            comma separated if needed. eg: shift_override,user. Note: `user` is
            deprecated, use `assignee` instead.
          schema:
            type: string
            enum:
              - shift_override
              - user
              - assignee
              - shift_shadow
          required: false
        - name: from
          in: query
          description: >-
            Start range for shifts in ISO-8601 format (e.g.,
            2025-01-01T00:00:00Z or 2025-01-01T00:00:00+00:00)
          required: false
          schema:
            type: string
        - name: to
          in: query
          description: >-
            End range for shifts in ISO-8601 format (e.g., 2025-01-01T00:00:00Z
            or 2025-01-01T00:00:00+00:00)
          required: false
          schema:
            type: string
        - name: user_ids[]
          in: query
          schema:
            type: array
            items:
              type: integer
          style: form
          explode: true
          required: false
        - name: schedule_ids[]
          in: query
          schema:
            type: array
            items:
              type: string
          style: form
          explode: true
          required: false
        - name: page[number]
          in: query
          description: Page number (defaults to 1)
          required: false
          schema:
            type: integer
        - name: page[size]
          in: query
          description: Number of shifts per page (defaults to 50, max 1000)
          required: false
          schema:
            type: integer
      responses:
        '200':
          description: success
          content:
            application/vnd.api+json:
              schema:
                $ref: '#/components/schemas/shift_list'
        '404':
          description: resource not found
          content:
            application/vnd.api+json:
              schema:
                $ref: '#/components/schemas/errors_list'
      security:
        - bearer_auth: []
components:
  schemas:
    shift_list:
      type: object
      properties:
        data:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
                description: Unique ID of the shift
              type:
                type: string
                enum:
                  - shifts
              attributes:
                type: object
                allOf:
                  - $ref: '#/components/schemas/shift'
              relationships:
                $ref: '#/components/schemas/shift_relationships'
            required:
              - id
              - type
              - attributes
        meta:
          type: object
          allOf:
            - $ref: '#/components/schemas/meta'
      required:
        - data
    errors_list:
      type: object
      properties:
        errors:
          type: array
          items:
            type: object
            properties:
              title:
                type: string
              status:
                type: string
              code:
                type: string
                nullable: true
              detail:
                type: string
                nullable: true
            required:
              - title
              - status
    shift:
      type: object
      properties:
        schedule_id:
          type: string
          description: ID of schedule
          nullable: false
        rotation_id:
          type: string
          description: ID of rotation
          nullable: true
        starts_at:
          type: string
          description: Start datetime of shift
          nullable: false
        ends_at:
          type: string
          description: End datetime of shift
          nullable: false
        is_override:
          type: boolean
          description: Denotes shift is an override shift
        is_shadow:
          type: boolean
          description: Denotes shift is a shadow shift
        user_id:
          type: integer
          description: ID of user on shift
          nullable: true
      required:
        - schedule_id
        - rotation_id
        - starts_at
        - ends_at
        - is_override
        - is_shadow
    shift_relationships:
      type: object
      properties:
        shift_override:
          type: object
          properties:
            data:
              type: object
              properties:
                id:
                  type: string
                type:
                  type: string
                  enum:
                    - shift_overrides
              nullable: true
        user:
          type: object
          properties:
            data:
              type: object
              properties:
                id:
                  type: string
                type:
                  type: string
                  enum:
                    - users
              nullable: true
        assignee:
          type: object
          description: Assignee can be either a User or Schedule
          properties:
            data:
              type: object
              properties:
                id:
                  type: string
                type:
                  type: string
              nullable: true
    meta:
      type: object
      properties:
        next_cursor:
          type: string
          nullable: true
        current_page:
          type: integer
          nullable: true
        next_page:
          type: integer
          nullable: true
        prev_page:
          type: integer
          nullable: true
        total_count:
          type: integer
        total_pages:
          type: integer
      required:
        - current_page
        - next_page
        - prev_page
        - total_count
        - total_pages
  securitySchemes:
    bearer_auth:
      type: http
      scheme: bearer

````